// ---------------------------------------------------
// ---------------------------------------------------
// ---------------------------------------------------
// ---------------------------------------------------
// ---------------------------------------------------
// ----                                           ----
// ----                                           ----
// ----               HELLO WORLD !               ----
// ----                                           ----
// ----                                           ----
// ----      Program Title: Kids Calculator       ----
// ----                                           ----
// ----                                           ----
// ----    Date Published: July 29th, 2018 [GR]   ----
// ----                                           ----
// ----                                           ----
// ----         Developed by: [WISE PIED]         ----
// ----                                           ----
// ----                                           ----
// ---------------------------------------------------
// ---------------------------------------------------
// ---------------------------------------------------
// ---------------------------------------------------
// ---------------------------------------------------



import javafx.application.Application;
import javafx.geometry.Pos;
import javafx.geometry.HPos;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.stage.Stage;
import java.lang.Double;
import java.lang.String;

public class KidsCalculator extends Application {
	
	private TextField grandNombre         = new TextField();
	private TextField petitNombre         = new TextField();
	private TextField whatIsTheAnswer     = new TextField();
	
	private Label operator 				  = new Label("operator?");
	private Label equatesTo 			  = new Label("=");
	
	@Override
	public void start(Stage primaryStage) {
		
		grandNombre.setEditable(true);
		petitNombre.setEditable(true);
		whatIsTheAnswer.setEditable(false);
		
		Button btAdd   = new Button("Add");
		Button btSub   = new Button("Subtract");
		Button btMult  = new Button("Multiply");
		Button btDiv   = new Button("Divide");
		Button btClear = new Button("Clear");
		
		btAdd.setOnAction(  e ->      add());
		btSub.setOnAction(  e -> subtract());
		btMult.setOnAction( e -> multiply());
		btDiv.setOnAction(  e ->   divide());
		
		btClear.setOnAction( e -> {
			
			grandNombre.setText("");
			petitNombre.setText("");
			whatIsTheAnswer.setText("");
			operator.setText("operator?");
			
		});
		
		GridPane layout = new GridPane();
		
		layout.setAlignment(Pos.CENTER);
		layout.setPadding(new Insets(11.5, 12.5, 13.5, 14.5));
		layout.setHgap(5.5);
		layout.setVgap(5.5);
		
		layout.add(new Label( "Larger Number"), 0, 0);
		layout.add(new Label("Smaller Number"), 0, 2);
		layout.add(new Label(        "Answer"), 0, 4);
		
		layout.add(grandNombre,                 1, 0);
		layout.add(operator,                    1, 1);
		layout.add(petitNombre,                 1, 2);
		layout.add(equatesTo,                   1, 3);
		layout.add(whatIsTheAnswer,             1, 4);
		
		layout.add(btAdd,                       2, 0);
		layout.add(btSub,                       2, 1);
		layout.add(btMult,                      2, 2);
		layout.add(btDiv,                       2, 3);
		layout.add(btClear,                     2, 4);
		
		GridPane.setHalignment(operator,   HPos.LEFT);
		GridPane.setHalignment(equatesTo,  HPos.LEFT);
		
		Scene scene = new Scene(layout);
		
		primaryStage.setTitle("Kids Calculator"); // Set Title
		primaryStage.setScene(scene);
		primaryStage.show();
		
	}
	
	// Method 'add()' is the method that is called directly by
	// the user when they select the 'Add' button. An answer 
	// will be produced and shown in the answer field if and 
	// only if fields are not empty, and data input is verified.
	private void add() {

		operator.setText("+");
		
		colorGuard();
		
		cleanUp();
		
		emptyFieldCheck();
		
		if(verify(grandNombre.getText()) == true && verify(petitNombre.getText()) == true) {
			
			whatIsTheAnswer.setText(String.valueOf(addition(Double.parseDouble(grandNombre.getText()), Double.parseDouble(petitNombre.getText()))));
			whatIsTheAnswer.setStyle("-fx-text-fill: green");
			
		} else {
		
			fieldVerification();
			
		}
		
	}
	
	// Method 'subtract()' is the method that is called directly by
	// the user when they select the 'Subtract' button. An answer 
	// will be produced and shown in the answer field if and 
	// only if fields are not empty, and data input is verified.
	private void subtract() {

		operator.setText("-");
		
		colorGuard();
		
		cleanUp();
		
		emptyFieldCheck();
		
		if(verify(grandNombre.getText()) == true && verify(petitNombre.getText()) == true) {

			whatIsTheAnswer.setText(String.valueOf(subtraction(Double.parseDouble(grandNombre.getText()), Double.parseDouble(petitNombre.getText()))));
			whatIsTheAnswer.setStyle("-fx-text-fill: green");
			
		} else {
		
			fieldVerification();
		
		}
		
	}
	
	// Method 'multiply()' is the method that is called directly by
	// the user when they select the 'Multiply' button. An answer 
	// will be produced and shown in the answer field if and 
	// only if fields are not empty, and data input is verified.
	private void multiply() {
		
		operator.setText("x");
		
		colorGuard();
		
		cleanUp();
		
		emptyFieldCheck();
		
		if(verify(grandNombre.getText()) == true && verify(petitNombre.getText()) == true) {

			whatIsTheAnswer.setText(String.valueOf(multiplication(Double.parseDouble(grandNombre.getText()), Double.parseDouble(petitNombre.getText()))));
			whatIsTheAnswer.setStyle("-fx-text-fill: green");
			
		} else {
		
			fieldVerification();
		
		}
		
	}
	
	// Method 'divide()' is the method that is called directly by
	// the user when they select the 'Divide' button. An answer 
	// will be produced and shown in the answer field if and 
	// only if fields are not empty, and data input is verified.
	private void divide() {

		operator.setText("/");
		
		colorGuard();
		
		cleanUp();
		
		emptyFieldCheck();
		
		if(verify(grandNombre.getText()) == true && verify(petitNombre.getText()) == true) {
			
			if(Double.parseDouble(grandNombre.getText()) == 0 && Double.parseDouble(petitNombre.getText()) == 0) {
				
				whatIsTheAnswer.setText("Cannot Compute");
				grandNombre.setStyle("-fx-text-fill: red");
				petitNombre.setStyle("-fx-text-fill: red");
				whatIsTheAnswer.setStyle("-fx-text-fill: red");
				
			} 
			
			else if(Double.parseDouble(grandNombre.getText()) > 0 && Double.parseDouble(petitNombre.getText()) == 0) {
				
				whatIsTheAnswer.setText("Cannot Compute");
				petitNombre.setStyle("-fx-text-fill: red");
				whatIsTheAnswer.setStyle("-fx-text-fill: red");
				
			} else {
	
				whatIsTheAnswer.setText(String.valueOf(division(Double.parseDouble(grandNombre.getText()), Double.parseDouble(petitNombre.getText()))));
				whatIsTheAnswer.setStyle("-fx-text-fill: green");
				
			}
			
		} else {
		
			fieldVerification();
			
		}
		
	}
	
	// Method 'colorGuard()' resets color of text to default after 
	// 'verify' method confirms no errors in input and before 
	// the selected mathematical operation is executed. This method
	// can be found in the methods 'add()', 'subtract()', 'multiply()', 
	// 'divide()'.
	private void colorGuard() {
			
			grandNombre.setStyle("-fx-text-fill: black");
			petitNombre.setStyle("-fx-text-fill: black");
			
	}
	
	// Method 'emptyFieldCheck()' is called first by methods 'add()', 
	// 'subtract()', 'multiply()', and 'divide()' to determine if 
	// a data field other than the answer field is without input.
	// Text messages will display in the text fields for any field 
	// found to be empty when a mathematical operation is selected 
	// for execution.
	private void emptyFieldCheck() {
		
		if(grandNombre.getText().isEmpty() && petitNombre.getText().isEmpty()) {
			
			grandNombre.setText("Enter Value");
			petitNombre.setText("Enter Value");
			whatIsTheAnswer.setText("Enter Numbers Only");
			grandNombre.setStyle("-fx-text-fill: red");
			petitNombre.setStyle("-fx-text-fill: red");
			whatIsTheAnswer.setStyle("-fx-text-fill: red");
		
		}
		
		else if(grandNombre.getText().isEmpty() && !petitNombre.getText().isEmpty()) {
			
			if(verify(petitNombre.getText()) == false) {

				petitNombre.setStyle("-fx-text-fill: red");
				
			}
			
			grandNombre.setText("Enter Value");
			whatIsTheAnswer.setText("Enter Numbers Only");
			grandNombre.setStyle("-fx-text-fill: red");
			whatIsTheAnswer.setStyle("-fx-text-fill: red");
		
		}
			
		else if(!grandNombre.getText().isEmpty() && petitNombre.getText().isEmpty()) {
			
			if(verify(grandNombre.getText()) == false) {
				
				grandNombre.setStyle("-fx-text-fill: red");
				
			}

			petitNombre.setText("Enter Value");
			whatIsTheAnswer.setText("Enter Numbers Only");
			petitNombre.setStyle("-fx-text-fill: red");
			whatIsTheAnswer.setStyle("-fx-text-fill: red");
			
		}
		
	}
	
	// Method 'fieldVerification()' can be accessed by any mathematical
	// operation's button selection if input is found in both the data 
	// fields, but the input does not pass verification.
	private void fieldVerification() {
	
		if(verify(grandNombre.getText()) == false && verify(petitNombre.getText()) == false) {
			
			whatIsTheAnswer.setText("Enter Numbers Only");
			grandNombre.setStyle("-fx-text-fill: red");
			petitNombre.setStyle("-fx-text-fill: red");
			whatIsTheAnswer.setStyle("-fx-text-fill: red");
			
		}

		else if(verify(grandNombre.getText()) == true && verify(petitNombre.getText()) == false) {
			
			whatIsTheAnswer.setText("Enter Numbers Only");
			petitNombre.setStyle("-fx-text-fill: red");
			whatIsTheAnswer.setStyle("-fx-text-fill: red");
			
		}
		
		else if(verify(grandNombre.getText()) == false && verify(petitNombre.getText()) == true) {
			
			whatIsTheAnswer.setText("Enter Numbers Only");
			grandNombre.setStyle("-fx-text-fill: red");
			whatIsTheAnswer.setStyle("-fx-text-fill: red");
			
		}
	
	}
	
	// Method 'verify(String)' for verifying the input of data into 
	// the text fields. This executes only if input is found in both
	// text fields. If more than one decimal is found, the length of 
	// the entered value is greater than 21, or if any data entered 
	// is not a digit, the input will not pass verification.
	private boolean verify(String value) {
		
		char point = '.';
		int  points = 0;
		
		if (value.length() > 21) {
			
			return false;

		}
		
		for(char m : value.toCharArray()) {
			
			if(!Character.isDigit(m) && m != point) {
				
				return false;
			
			}
			
			if(m == point) {
				
				if(value.length() == 1) {
				
					return false;
				
				}
				
				points+=1;
				
			}
			
			if(points >= 2) {
				
				return false;
				
			}
			
		}
		
		return true;
		
	}
	
	// The method cleanUp() scouts out the previous entry, and if  
	// the values of either the larger or smaller number does not 
	// equate to a String value of "Enter Value", the corresponding
	// fields, both of which are tested, will call on the method
	// cleanUpField(String) to remove space and converts a String
	// value of a point ('.') to a double value of zero-point-zero,
	// or ('0.0') in String format, and then sets the corresponding
	// entry field, either Larger or Smaller Number, or both, to 
	// a value that should allow for a proper mathematical conversion
	// for the intended mathematical operation being selected.
	private void cleanUp() {
		
		if(!grandNombre.getText().equals("Enter Value")) {
			
			grandNombre.setText(cleanUpField(grandNombre.getText()));
		
		}
		
		if(!petitNombre.getText().equals("Enter Value")) {
			
			petitNombre.setText(cleanUpField(petitNombre.getText()));
		
		}
		
	}
	
	// The 'cleanUpField()' method will negate all whitespace entered into
	// the text fields. While this happens, this method calls upon the 
	// cleanUpDecimals() method to change any field found to contain but a 
	// single decimal after whitespace is cleared into a digit of zero
	private String cleanUpField(String value) {
		
		value = value.replaceAll("\\s","");
		
		if(value.contentEquals(".")) {
			
			value = "0.0";
			
		}
		
		return value;
		
	}

	// Method for Mathematical Operation: Addition
	private double addition(double first, double second) {
		
		double product = first + second;
		return product;
		
	}
	
	// Method for Mathematical Operation: Subtraction
	private double subtraction(double first, double second) {
		
		double product = first - second;
		return product;
		
	}
	
	// Method for Mathematical Operation: Multiplication
	private double multiplication(double first, double second) {
		
		double product = first * second;
		return product;
		
	}
	
	// Method for Mathematical Operation: Division
	private double division(double first, double second) {
		
		double product = first / second;
		return product;
		
	}
	
	// This makes the program run
	public static void main(String[] args) {
		
		Application.launch(args); // This code launches the application
		
	}
	
}